package com.cristobalbernal.loladvisor.dao;

import com.cristobalbernal.loladvisor.config.AppConfig;
import com.cristobalbernal.loladvisor.model.Lol;
import org.springframework.stereotype.Repository;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;

@Repository
public class LolDaoImplMemory implements LolDao{

    public List<Lol> lols = new ArrayList<>();

    private AppConfig config;

    public void init() {
        lols = UtilLolFileReader.readFile(config.getFile(),config.getSeparator(),config.getListSeparator());
    }


    @Override
    public Lol findById(long id) {

        Optional<Lol> result = lols
                .stream()
                .filter(f -> f.getId() == id)
                .findFirst();

        // @formatter:on

        return result.orElse(null);
    }

    @Override
    public Collection<Lol> findAll() {
        return lols;
    }

    @Override
    public void insert(Lol lol) {
        lols.add(lol);
    }

    @Override
    public void edit(Lol lol) {
        int index = getIndexOf(lol.getId());
        if(index != -1)
            lols.set(index, lol);
    }

    @Override
    public void delete(long id) {
        int index = getIndexOf(id);
        if(index != -1)
            lols.remove(index);
    }

    private int getIndexOf(long id) {
        boolean encontrado = false;
        int index = 0;

        while(!encontrado && index < lols.size()) {
            if(lols.get(index).getId() == id)
                encontrado = true;
            else
                index++;
        }
        return (encontrado) ? index : -1;
    }


}
