package com.cristobalbernal.loladvisor.dao;

import com.cristobalbernal.loladvisor.model.Lol;
import org.springframework.util.ResourceUtils;

import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class UtilLolFileReader {
    public static List<Lol> readFile(final String path, final String separator, final String listSeparator) {
        List<Lol> result = new ArrayList<>();


        try {
            // @formatter:off
            result = Files
                    .lines(Paths.get(ResourceUtils.getFile(path).toURI()))
                    .skip(1)
                    .map(line -> {
                        String[] values = line.split(separator);
                        return new Lol(Long.parseLong(values[0]), values[1], values[2],
                                values[3]);
                    }).collect(Collectors.toList());
            // @formatter:on


        } catch (Exception e) {
            System.err.println("Error de lectura del fichero de datos");
            System.exit(-1);
        }
        return result;
    }
}
